import { createI18n } from "vue-i18n";
import messages from "src/i18n";
import { boot } from "quasar/wrappers";

export default boot(({ app }) => {
  // Create I18n instance
  const i18n = createI18n({
    locale: "en-US",
    globalInjection: true,
    legacy: false,
    messages,
  });

  // Tell app to use the I18n instance
  app.use(i18n);
});
